﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Tsi1.BusinessLayer.DataLoad;

namespace Tsi1.Api.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class DataLoadController : ControllerBase
    {
        private readonly IDataLoad _dataLoad;

        public DataLoadController(IDataLoad dataLoad)
        {
            _dataLoad = dataLoad;
        }

        [AllowAnonymous]
        [HttpGet("LoadData")]
        public async Task<IActionResult> LoadData()
        {
            await _dataLoad.LoadDataAsync();

            return Ok();
        }
    }
}
