﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Design;
using Microsoft.Extensions.Configuration;
using System.IO;

namespace Tsi1.DataLayer
{
    public class DesignTimeDbContextFactory : IDesignTimeDbContextFactory<Tsi1Context>
    {
        public Tsi1Context CreateDbContext(string[] args)
        {
            IConfigurationRoot configuration = new ConfigurationBuilder()
                .SetBasePath(Directory.GetCurrentDirectory())
                .AddJsonFile(@Directory.GetCurrentDirectory() + "/../Tsi1.Api/appsettings.json")
                .Build();

            var connectionString = configuration.GetConnectionString("PostgreSql");
            var builder = new DbContextOptionsBuilder<Tsi1Context>();
            builder.UseNpgsql(connectionString);

            return new Tsi1Context(builder.Options);
        }
    }
}
