﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using System;
using System.Collections.Generic;
using System.Text;
using Tsi1.DataLayer.Entities;

namespace Tsi1.DataLayer.EntityConfiguration
{
    public class CourseConfiguration : IEntityTypeConfiguration<Course>
    {
        public void Configure(EntityTypeBuilder<Course> builder)
        {
            builder.HasKey(x => x.Id);

            builder.HasIndex(x => new { x.Name, x.TenantId })
                .IsUnique();

            builder.Property(x => x.Name)
                .IsRequired()
                .HasColumnType("character varying(50)");

            builder.Property(x => x.IsTemplate)
                .IsRequired();

            builder.HasOne(x => x.Tenant)
                .WithMany(x => x.Courses)
                .HasForeignKey(x => x.TenantId);
        }
    }
}
