﻿using Microsoft.EntityFrameworkCore.Migrations;

namespace Tsi1.DataLayer.Migrations
{
    public partial class fixMultiTenant : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Forums_Tenants_TenantId",
                table: "Forums");

            migrationBuilder.DropForeignKey(
                name: "FK_PostMessages_Tenants_TenantId",
                table: "PostMessages");

            migrationBuilder.DropForeignKey(
                name: "FK_Posts_Tenants_TenantId",
                table: "Posts");

            migrationBuilder.DropIndex(
                name: "IX_Posts_TenantId",
                table: "Posts");

            migrationBuilder.DropIndex(
                name: "IX_Posts_ForumId_Title_TenantId",
                table: "Posts");

            migrationBuilder.DropIndex(
                name: "IX_PostMessages_TenantId",
                table: "PostMessages");

            migrationBuilder.DropIndex(
                name: "IX_Forums_TenantId",
                table: "Forums");

            migrationBuilder.DropIndex(
                name: "IX_Forums_CourseId_Name_TenantId",
                table: "Forums");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "Posts");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "PostMessages");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "Forums");

            migrationBuilder.CreateIndex(
                name: "IX_Posts_ForumId_Title",
                table: "Posts",
                columns: new[] { "ForumId", "Title" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Forums_CourseId_Name",
                table: "Forums",
                columns: new[] { "CourseId", "Name" },
                unique: true);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropIndex(
                name: "IX_Posts_ForumId_Title",
                table: "Posts");

            migrationBuilder.DropIndex(
                name: "IX_Forums_CourseId_Name",
                table: "Forums");

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "Posts",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "PostMessages",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "Forums",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateIndex(
                name: "IX_Posts_TenantId",
                table: "Posts",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Posts_ForumId_Title_TenantId",
                table: "Posts",
                columns: new[] { "ForumId", "Title", "TenantId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_PostMessages_TenantId",
                table: "PostMessages",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Forums_TenantId",
                table: "Forums",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Forums_CourseId_Name_TenantId",
                table: "Forums",
                columns: new[] { "CourseId", "Name", "TenantId" },
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_Forums_Tenants_TenantId",
                table: "Forums",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_PostMessages_Tenants_TenantId",
                table: "PostMessages",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Posts_Tenants_TenantId",
                table: "Posts",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
